*------------------------------------------------------------------------------
* duesform.prg subroutines
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
procedure prtCond     && {set printer to condensed mode}
   @ 0,0 say chr(27)+'(s16.66H'+chr(27)+'&l5C' && {LaserJet II}
return
procedure prtNorm     && {set printer to normal mode}
   @ 0,0 say chr(27)+'(s10H'+chr(27)+'&l8C'    && {LaserJet II}
return
procedure prtFont
   @ 0,0 say chr(27)+'(110U'
   @ 0,1
return
procedure prtLand     && {set printer to landscape}
   @ 0,0 say chr(27)+'&l1O'                    && {LaserJet II}
   @ 0,1
return
procedure prtPort     && {set printer to portrait}
   @ 0,0 say chr(27)+'&l0O'                    && {LaserJet II}
return

*------------------------------------------------------------------------------
procedure dojoMenu
parameter doj,dojname,dojoid,all
*  on entry: dojoid=0 => do menu,      # => loop on dojo
*  on exit:  dojoid=# => dojo to do,  -1 => eof; doj/dojname = current dojo
private i, ok
   ok = .F.
   doj = ' '
   dojname = ' '
   select b
   set filter to dojofedid > 6000 .and. dojofedid < 7000 &&  {SCKF}
   goto top
   if dojoid = 0 && {do menu}
      set status off
      set device to screen
      @  3,0 clear
      i = 3
      do while .not. eof()
         @  i,10 say abbrev+'  '+trim(dojoname)
         skip
         i = i + 1
      enddo
      do while .not. ok
         @ 23,0 clear
         accept ' Enter dojo abbreviation, or ALL: ' to doj
         doj = trim(upper(doj))
         goto top
         if doj = 'ALL'
            ok = .T.
            doj = trim(abbrev)
            dojname = trim(dojoname)
            if .not. eof()
               dojoid = dojofedid && {set up for next dojo}
               all = .T.
            else
               dojoid = -1
               all = .F.
            endif
         else
            locate for abbrev = doj
            if found()
               ok = .T.
               dojname = trim(dojoname)
               dojoid = dojofedid
            else
               @ 20,0 
               ? chr(7)
            endif
            all = .F.
         endif
      enddo
* note: assumes printer selected on entry, so set back
      set status on
      set device to print
   else
      locate for dojofedid = dojoid
      if found()
         skip
         doj = trim(abbrev)
         dojname = trim(dojoname)
         if .not. eof()
            dojoid = dojofedid
         else
            dojoid = -1
            all = .F.
         endif
      else
         dojoid = -1
         all = .F.
      endif
   endif
   select a
return

*------------------------------------------------------------------------------
procedure decRank
parameters ranknum,rankstr
private div, rem
   do case
      case ranknum = -1
         rankstr = '--'
      case ranknum = 1
         rankstr = 'ABS'
      case ranknum > 1
         div    = int(ranknum/100)
         rem    = mod(ranknum,100)
         if div = 3
            rankstr = '0 '
         else
            if div < 10
               rankstr = ltrim(trim(str(10-div)))
               do case
                  case rem = 0
                     rankstr = rankstr + '-'
                  case rem = 1
                     rankstr = rankstr + ' '
                  case rem = 2
                     rankstr = rankstr + '+'
               endcase
            else
               rankstr = ltrim(trim(str(div/10))) + 'D'
               do case
                  case rem = 0
                     rankstr = rankstr + ' '
                  case rem = 1
                     rankstr = rankstr + 'R'
                  case rem = 2
                     rankstr = rankstr + 'K'
                  case rem = 3
                     rankstr = rankstr + 'H'
               endcase
            endif
         endif
      else
         rankstr = '    '
      endif
   endcase
return   

*------------------------------------------------------------------------------
procedure decHt
parameters htnum,htstr
private ft, in
   ft = int(htnum/12)
   in = mod(htnum,12)
   htstr = ltrim(str(ft)) + "'" + ltrim(str(in))
   do while len(htstr) < 6
      htstr = htstr + ' '
   enddo
   htstr = htstr + '"'
return

*------------------------------------------------------------------------------
procedure encHt
parameters htstr,htnum
private ft,in,i
   i  = at("'",htstr)
   ft = val(left(htstr,i-1))
   in = val(substr(htstr,i+1,len(htstr)-i-1))
   htnum = ft*12 + in
return

*------------------------------------------------------------------------------
procedure encRank
parameters rankstr,ranknum
private r,c,d
   d = 0
   rankstr = upper(rankstr)
   r = val(substr(rankstr,1,1))
   if at('D',rankstr) = 2
      c = substr(rankstr,3,1)
      do case
         case c = 'R'
            d = 1
         case c = 'K'
            d = 2
         case c = 'H'
            d = 3
      endcase
      ranknum = r*1000 + d
   else
      if r = 0
         ranknum = 301
      else
         c = substr(rankstr,2,1)
         do case
            case c = '-'
               d = 0
            case c = ' '
               d = 1
            case c = '+'
               d = 2
         endcase
         ranknum = (10-r)*100 + d
      endif
   endif
return

*------------------------------------------------------------------------------
procedure updCur
parameters current
private rnk,doj,nam
   doj = dojofedid
   dojoname = " "
   select b
   locate for doj = dojofedid
   if found()
      dojoname = trim(abbrev)
   endif
   select a 
   current = trim(dojoname)

   rnk = ' '
   do decRank with rankcode,rnk
   current = current+' '+rnk
   if usefirst
      nam = firstname
   else
      nam = midname
   endif

   current = current + ' ' + trim(lastname)+', '+trim(nam)
   current = current + ' ' + dtoc(birthdate)
   current = current + ' ' + trim(taikai)

return

